#version 300 es

#define f32  float
#define v2   vec2
#define Rgba vec4
#define v4   vec4
#define u32  uint

precision mediump float;

in v2   uvs;
in v4   sampling_uvs;
in Rgba colour;
flat in  u32  texture_to_sample;
out Rgba final_colour;

uniform sampler2D font_map;
uniform sampler2D big_font_map;
uniform sampler2D icons_map;
uniform sampler2D general_atlas;

// @@@@ Make sure these stay in sync with the values in assets.h!
#define NO_ATLAS       uint(0)
#define FONT_ATLAS     uint(1)
#define BIG_FONT_ATLAS uint(2)
#define ICONS_ATLAS    uint(3)
#define GENERAL_ATLAS  uint(4)
/////////////////////////////////////////////////////////////////

void main()
{
    v2 adjusted_uvs = sampling_uvs.xy + uvs * sampling_uvs.zw;

    Rgba texture_colour = Rgba(1, 1, 1, 1);
    if(texture_to_sample == FONT_ATLAS)
    {
        Rgba value = texture(font_map, adjusted_uvs);
        texture_colour.a = value.r;
    }
    else if(texture_to_sample == BIG_FONT_ATLAS)
    {
        Rgba value = texture(big_font_map, adjusted_uvs);
        texture_colour.a = value.r;
    }
    else if(texture_to_sample == ICONS_ATLAS)
    {
        Rgba value = texture(icons_map, adjusted_uvs);
        texture_colour.a = value.r;
    }
    else if(texture_to_sample == GENERAL_ATLAS)
    {
        Rgba value = texture(general_atlas, adjusted_uvs);
        texture_colour = value;
    }
    
    final_colour = colour * texture_colour;
}