#version 300 es

#define s32  int
#define u32  uint
#define f32  float
#define v2   vec2
#define Rgba vec4
#define v4   vec4

layout(location = 0) in v2   base_position;
layout(location = 1) in v2   wanted_position;
layout(location = 2) in v2   scale;
layout(location = 3) in v2   incoming_uvs;
layout(location = 4) in v4   incoming_sampling_uvs;
layout(location = 5) in Rgba incoming_colour;
layout(location = 6) in u32  incoming_texture_to_sample;

uniform Renderer_Info
{
    s32 rt_width;
    s32 rt_height;
};

out v2   uvs;
out v4   sampling_uvs;
out Rgba colour;
flat out u32  texture_to_sample;

void main()
{
    v2  rt_dimensions = v2(rt_width, rt_height);
    
    v2 position = (wanted_position / rt_dimensions) * 2.0f - 1.0f;
    position += base_position * scale / rt_dimensions;

    uvs               = incoming_uvs;
    sampling_uvs      = incoming_sampling_uvs;
    colour            = incoming_colour;
    texture_to_sample = incoming_texture_to_sample;
    
    gl_Position = v4(position, 0, 1);
}